/*
 * alist.c - association list
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#if 0
#include <sys/types.h>
#ifdef TIME_WITH_SYS_TIME
 #include <sys/time.h>
 #include <time.h>
#else
 #ifdef HAVE_SYS_TIME_H
  #include <sys/time.h>
 #else
  #include <time.h>
 #endif
#endif
#include <errno.h>
#endif


#include "alist.h"


int
assoc_n(apair_t *al, char *xname)
{
    int i;
    apair_t *ret;

    ret = NULL;
    i = 0;
    while(al[i].name) {
        if(strcasecmp(al[i].name, xname)==0) {
            ret = &al[i];
        }
        i++;
    }

    if(ret)
        return ret->value;
    else
        return -1;
}

static char *ignore_msg = "*ignore*";

char*
assoc_v(apair_t *al, int xval)
{
    int i;
    apair_t *ret;

    ret = NULL;
    i = 0;
    while(al[i].name) {
        if(al[i].value == xval) {
            ret = &al[i];
        }
        i++;
    }

    if(ret)
        return ret->name;
    else
        return ignore_msg; 
}

void*
assoc_p(apair_t *al, int xval)
{
    int i;
    apair_t *ret;

    ret = NULL;
    i = 0;
    while(al[i].name) {
        if(al[i].value == xval) {
            ret = &al[i];
        }
        i++;
    }

    if(ret)
        return (void*)ret->name;
    else
        return NULL; 
}
