/*
 *
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <sys/types.h>
#ifdef HAVE_INTTYPES_H
#include <inttypes.h>
#endif
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <jpeglib.h>

#include "alist.h"
#include "sentry.h"


#define OUTBUF_SIZE (16*1024)

unsigned char outbuf[OUTBUF_SIZE];

void x_src_init(j_decompress_ptr cinfo)
{
/*
  PASS;
*/
}

boolean x_src_isempty(j_decompress_ptr cinfo)
{
/*
  PASS;
*/
  return FALSE;
}

void x_src_input_data(j_decompress_ptr cinfo, long any)
{
/*
  PASS;
*/
}

boolean x_src_sync(j_decompress_ptr cinfo, int any)
{
/*
  PASS;
*/
  return FALSE;
}

void x_src_term(j_decompress_ptr cinfo)
{
/*
  PASS;
*/
}


int
decode_jpeg(unsigned char *raw_data, int raw_len,
    unsigned char *out_area, int *rwid, int *rht)
{

    struct jpeg_decompress_struct cinfo;
    struct jpeg_error_mgr jerr;
    struct jpeg_source_mgr src_mgr;
    JSAMPROW bufptr[1];
    int wid, ht;
    int chk;

    JDIMENSION num_scanlines;

    if(debug>=100) {
        fprintf(stderr, 
"decode_jpeg: from %p, len %d\n\
             to   %p, &wid %p, &ht %p\n",
            raw_data, raw_len, out_area, rwid, rht);
    }

#if 0
dump_to_file("/var/tmp/x.jpg", raw_data, raw_len);
#endif


    src_mgr.next_input_byte     = raw_data;
    src_mgr.bytes_in_buffer     = raw_len;
    src_mgr.init_source         = x_src_init;
    src_mgr.fill_input_buffer   = x_src_isempty;
    src_mgr.skip_input_data     = x_src_input_data;
    src_mgr.resync_to_restart   = x_src_sync;
    src_mgr.term_source         = x_src_term;


    cinfo.err = jpeg_std_error(&jerr);
    jpeg_create_decompress(&cinfo);

    cinfo.src = &src_mgr;
    cinfo.out_color_space = JCS_RGB;

    chk = jpeg_read_header(&cinfo, TRUE);

    chk = jpeg_start_decompress(&cinfo);

    if(debug>=100) {
    printf("wid %d, ht %d\n",
        cinfo.output_width, cinfo.output_height);
    }

    *rwid = cinfo.output_width;
    *rht  = cinfo.output_height;

    while (cinfo.output_scanline < cinfo.output_height) {
        bufptr[0] = (JSAMPROW) &out_area[
                        cinfo.output_width*3*cinfo.output_scanline];
        num_scanlines = jpeg_read_scanlines(&cinfo, bufptr, 1);
    }

    (void) jpeg_finish_decompress(&cinfo);
    jpeg_destroy_decompress(&cinfo);

#if 0
 {
    static int pno=0;
    char fname[128];
    char tmp[128];
    int fd;

    sprintf(tmp, "P6\n%d\n%d\n255\n",
        cinfo.output_width, cinfo.output_height);

    sprintf(fname, "/var/tmp/p%d", pno%8);
    fd = open(fname, O_WRONLY|O_CREAT|O_TRUNC, 0777);
    if(fd<0) {
    }
    else {
        chk = write(fd, tmp, strlen(tmp));
        chk = write(fd, out_area, cinfo.output_width*cinfo.output_height*3);
        printf("file %3d: chk %d\n", pno, chk);
        close(fd);
    }

    pno++;
 }
#endif


    return 0;
}

